##
##  kustomize.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_kustomize_base 4.5.7
%define       V_kustomize_snap 20220802

#   package information
Name:         kustomize
Summary:      Kubernetes Configuration Customization Tool
URL:          https://github.com/kubernetes-sigs/kustomize
Vendor:       Kubernetes Community
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Web
License:      Apache
Version:      %{V_kustomize_base}.%{V_kustomize_snap}
Release:      20220802

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/kustomize/kustomize-%{V_kustomize_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Kustomize lets you customize raw, template-free YAML files for
    multiple purposes, leaving the original YAML untouched and usable
    as is. Kustomize targets Kubernetes. It understands and can patch
    Kubernetes style API objects. It's like make(1), in that what it
    does is declared in a file, and it's like sed(1), in that it emits
    editted text.

%track
    prog kustomize:release = {
        version   = %{V_kustomize_base}
        url       = https://github.com/kubernetes-sigs/kustomize/releases
        regex     = v(\d+\.\d+\.\d+)\.tar\.gz
    }
    prog kustomize:snapshot = {
        version   = %{V_kustomize_snap}
        url       = http://download.openpkg.org/components/versioned/kustomize/
        regex     = kustomize-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n kustomize

%build
    #   build program
    export GOPATH=`pwd`
    cd src/sigs.k8s.io/kustomize/kustomize
    go build -v -o kustomize.exe main.go

%install
    #   create directory hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin

    #   install program
    %{l_shtool} install -c -s -m 755 \
        src/sigs.k8s.io/kustomize/kustomize/kustomize.exe \
        $RPM_BUILD_ROOT%{l_prefix}/bin/kustomize

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

